<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTicket
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.3 build:20091102
*/

session_start();
require_once('bin/qti_init.php');
include(Translate('qti_adm.php'));
include(Translate('qtim_import.php'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// FUNCTIONS

function CsvToSql($str,$strNull='NULL',$strReturn='NULL',$bEnclose=true)
{
  if ( is_null($str) ) return $strReturn;
  if ( $str===$strNull || $str==='' || $str==='""' ) return $strReturn;
  if ( !$bEnclose ) return $str;
  return '"'.addslashes($str).'"';
}

function startElement($parser, $strTag, $arrTagAttr) 
{
  $strTag = strtolower($strTag);
  global $arrTopic,$arrPosts;
  global $t,$p,$f,$ft,$d,$L;
  
  switch($strTag)
  {
  case 'topic':
    $arrTopic = array();
    $arrPosts = array();
    if ( isset($arrTagAttr['ID']) ) { $t=intval($arrTagAttr['ID']); } else { $t=0; }
    $arrTopic['id'] = $t;
    $arrTopic['type'] = (isset($arrTagAttr['TYPE']) ? $arrTagAttr['TYPE'] : 'T');
    break;
  case 'post':
    if ( isset($arrTagAttr['ID']) ) { $p=intval($arrTagAttr['ID']); } else { $p=0; }
    $arrPosts[$p] = array();
    $arrPosts[$p]['id'] = $p;
    $arrPosts[$p]['type'] = (isset($arrTagAttr['TYPE']) ? $arrTagAttr['TYPE'] : 'P');
    break;
  }
}
function characterData($parser, $data) 
{
  global $strValue;
  $strValue = trim($data);
}
function endElement($parser, $strTag) 
{
  $strTag = strtolower($strTag);

  global $arrTopic,$arrPosts;
  global $t,$p,$f,$ft,$d,$intTopicInsertId,$intPostInsertId;
  global $strValue;
  global $oDB;

  switch($strTag)
  {
  case 'x':         $arrTopic['x']=$strValue; break;
  case 'y':         $arrTopic['y']=$strValue; break;
  case 'z':         $arrTopic['z']=$strValue; break;
  case 'tags':      if ( !$_SESSION['m_import']['droptags'] ) { $arrTopic['tags']=$strValue; } break;
  case 'eventdate': $arrTopic['eventdate']=$strValue; break;
  case 'wisheddate':$arrTopic['wisheddate']=$strValue; break;
  case 'firstpostdate': if ( $_SESSION['m_import']['dropdate'] ) { $arrTopic['firstpostdate']=date('Ymd His'); } else { $arrTopic['firstpostdate']=$strValue; } break;
  case 'lastpostdate': if ( $_SESSION['m_import']['dropdate'] ) { $arrTopic['lastpostdate']=date('Ymd His'); } else { $arrTopic['lastpostdate']=$strValue; } break;
  
  case 'icon':     $arrPosts[$p]['icon']=$strValue; break;
  case 'title':    $arrPosts[$p]['title']=$strValue; break;
  case 'userid':   $arrPosts[$p]['userid']=$strValue; break;
  case 'username': $arrPosts[$p]['username']=$strValue; break;
  case 'issuedate':if ( $_SESSION['m_import']['dropdate'] ) { $arrPosts[$p]['issuedate']=date('Ymd His'); } else { $arrPosts[$p]['issuedate']=$strValue; } break;
  case 'modifdate':$arrPosts[$p]['modifdate']=$strValue; break;
  case 'modifuser':$arrPosts[$p]['modifuser']=$strValue; break;
  case 'modifname':$arrPosts[$p]['modifname']=$strValue; break;
  case 'textmsg':  $arrPosts[$p]['textmsg']=$strValue; break;  
  case 'posts':    $arrTopic['posts']=$arrPosts; break;

  case 'topic': 

    // Process topic

    $oTopic = new cTopic($arrTopic);
    $oTopic->section = $_SESSION['m_import']['dest'];
    $oTopic->id = $intTopicInsertId; $intTopicInsertId++;
    $oTopic->status = $_SESSION['m_import']['status'];
    
    $oTopic->InsertTopic(false,false,false);
    
    // Process posts

    foreach ($arrTopic['posts'] as $arrPost)
    {
      $oPost = new cPost($arrPost); if ( $_SESSION['m_import']['dropreply'] && $oPost->type!='P' ) break;
      $oPost->id = $intPostInsertId; $intPostInsertId++;
      $oPost->topic = $oTopic->id;
      $oPost->section = $_SESSION['m_import']['dest'];
      if ( $_SESSION['m_import']['dropbbc'] ) $oPost->text = QTunbbc($oPost->text);
      
      $oPost->InsertPost(false,false);
    }
    
    UpdateSectionStats($_SESSION['m_import']['dest'],false,true);
    
    break;

  default:
    if ( trim($strValue)!='' ) $arrTopic[$strTag]=$strValue;
    break;
  }
}

// INITIALISE

$intDest   = -1;
$bDropbbc  = false;
$bDropreply= false;
$bDroptags = false;
$bDropdate = false;
$bSkipfirst= true;
$strStatus = 'Z';
$strFormat = 'XML';
$strDelimit = ';';
$strEnclose = '"';
$strNull = 'NULL';

$oVIP->selfurl = 'qtim_import_adm.php';
$oVIP->selfname = $L['import']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['Version'].' 2.3<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check file
  
  $error = InvalidUpload($_FILES['title'],'xml,csv,txt,text,sql');

  // check form value

  if ( empty($error) )
  {
    $strFormat = trim($_POST['format']);
    if ( isset($_POST['dropbbc']) ) $bDropbbc=true;
    if ( isset($_POST['dropreply']) ) $bDropreply=true;
    if ( isset($_POST['droptags']) ) $bDroptags=true;
    if ( isset($_POST['dropdate']) ) $bDropdate=true;
    if ( isset($_POST['skip']) ) $bSkipfirst=true;
    $intDest = intval($_POST['section']);
    $strDelimit = trim($_POST['delimit']); if ( empty($strDelimit) ) $error=$L['import']['Delimiter'].' '.$L['E_invalid'];
    $strEnclose = $_POST['enclose']; if ( get_magic_quotes_gpc() ) $strEnclose = stripslashes($_POST['enclose']);
    $strNull = trim($_POST['null']);
    $strStatus = $_POST['status'];
    $_SESSION['m_import']=array('format'=>$strFormat,'dest'=>$intDest,'status'=>$strStatus,'dropbbc'=>$bDropbbc,'dropreply'=>$bDropreply,'droptags'=>$bDroptags,'dropdate'=>$bDropdate,'delimit'=>$strDelimit,'enclose'=>$strEnclose,'null'=>$strNull,'skip'=>$bSkipfirst);
  }

  // check values

  if ( empty($error) )
  {
    if ( strlen($strDelimit)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strDelimit) ) $error=$L['import']['Delimiter'].' '.$L['E_invalid'];
    }
    if ( strlen($strEnclose)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strEnclose) ) $error=$L['import']['Enclose'].' '.$L['E_invalid'];
    }
  }

  // IMPORT
  
  // ========
  if ( empty($error) ) {
  switch($strFormat) {
  // ========
  
  case 'CSV':

  // read lines
  $handle = fopen($_FILES['title']['tmp_name'],'r');
  if ( $handle )
  {
    if ( $bSkipfirst ) $str = fgets($handle);

    // -----
    $i = 0;
    $intCountPost = 0;
    $intCountTopic = 0;
    $intNextTopic = Nextid(TABTOPIC);

    while ( !feof($handle) )
    {
      $i++;
      $str = fgets($handle);
      if ( strlen($str)<4 ) continue;

      if ( $strFormat=='SQL' )
      {
      $str = trim(strstr($str,'VALUES ('));
      $str = substr($str, 8, -1);
      }
      // bbc html
      if ( $bDropbbc ) $str = QTunbbc($str);

      // import line (0:id 1:section 2:topic 3:type 4:username 5:title 6:issuedate 7:numid 8:textmsg 9:x 10:y 11:z 12:topictype, 13:tags
      if ( substr_count($str, $strDelimit)>7 )
      {
        $arrStr = explode($strDelimit,$str);

        if ( count($arrStr)==9 )
        {
          $arrStr[9]  = '0'; // add x,y,z if import from version 1.7
          $arrStr[10] = '0';
          $arrStr[11] = '0';
        }
        if ( count($arrStr)==11 )
        {
          $arrStr[12] = 'T'; // add topictype if import from version 2.x
          $arrStr[13] = ''; // add tags if import from version 2.x
        }

        if ( count($arrStr)==14 )
        {
          // pre-process values, remove encloser, html quote
          
          For ($j=0;$j<14;$j++)
          {
            $arrStr[$j]=trim($arrStr[$j]);
            if ( substr($arrStr[$j],0,1)==$strEnclose && substr($arrStr[$j],-1,1)==$strEnclose ) $arrStr[$j]=substr($arrStr[$j],1,-1);
            $arrStr[$j] = htmlspecialchars($arrStr[$j],ENT_QUOTES);
          }
          // issuedate old format handler
          if ( strlen($arrStr[6])>=14 ) $arrStr[6] = substr($arrStr[6],0,8).' '.substr($arrStr[6],-6,6);
          // if drop replies, drop dates or drop tags
          if ( $bDropreply && ($arrStr[3]=='R' || $arrStr[3]=='F') ) continue;
          if ( $bDropdate ) $arrStr[6]=Date('Ymd His');
          if ( $bDroptags ) $arrStr[13] = 'NULL';

          // insert post
          
          $intPost    = Nextid(TABPOST);
          $intTopic   = $intNextTopic+$arrStr[2];
          $strType    = CsvToSql($arrStr[3],$strNull,'"P"');
          $strUsername= CsvToSql($arrStr[4],$strNull,'"Visitor"');
          $strTitle   = CsvToSql($arrStr[5],$strNull,'""');
          $strIssue   = CsvToSql($arrStr[6],$strNull,'"0"');
          $intNumid   = CsvToSql($arrStr[7],$strNull,0,false);
          $strTextmsg = CsvToSql($arrStr[8],$strNull,'""'); if ( strlen($strTextmsg)>4 ) $strTextmsg = str_replace("\\n","\r\n",$strTextmsg);
          $strX = CsvToSql($arrStr[9],$strNull,0,false);
          $strY = CsvToSql($arrStr[10],$strNull,0,false);
          $strZ = CsvToSql($arrStr[11],$strNull,0,false);
          $strS = '"'.$strStatus.'"';
          $strSD = '"'.date('Ymd His').'"';
          $strTags = CsvToSql($arrStr[13],$strNull,'""');
          $oDB->Query( 'INSERT INTO '.TABPOST." (id,forum,topic,type,userid,username,title,issuedate,textmsg) VALUES ($intPost,$intDest,$intTopic,$strType,0,$strUsername,$strTitle,$strIssue,$strTextmsg)" );
          $intCountPost++;

          // insert topic

          if ( ($arrStr[3]=='P') || ($arrStr[3]=='A') )
          {
            if ( $arrStr[3]=='A' ) { $strType='"A"'; } else { $strType='"'.$arrStr[12].'"'; }
            $oDB->Query( 'INSERT INTO '.TABTOPIC." (id,numid,forum,type,status,statusdate,firstpostid,lastpostid,firstpostuser,lastpostuser,firstpostname,lastpostname,firstpostdate,lastpostdate,x,y,z,tags) VALUES ($intTopic,$intNumid,$intDest,$strType,$strS,$strSD,$intPost,$intPost,0,0,$strUsername,$strUsername,$strIssue,$strIssue,$strX,$strY,$strZ,$strTags)" );
            $intCountTopic++;
          }
        }
        else
        {
          $error='Number of parameters ('.count($arrStr).') not matching in line '.$i;
        }
      }
      else
      {
      $error='Not enough delimiters ('.substr_count($str, $strDelimit).') in line '.$i;
      }
    }
    // ----
    fclose($handle);

    // update stats
    if ( $intCountPost>0 || $intCountTopic>0 )
    {
    UpdateSectionStats($intDest,true,true); // update stats and re-compute lastpostdate,replies of the topic
    }
  }

  break;
  
  // ========
  
  case 'XML':
  
  $arrTopic = array();
  $arrPosts = array();
  $t = 0;
  $p = 0;
  $f = '0'; $ft='untitled';
  $d = 0;
  $strValue = '';
  $intTopicInsertId = Nextid(TABTOPIC);
  $intPostInsertId = Nextid(TABPOST);

  $xml_parser = xml_parser_create();
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);
  xml_set_element_handler($xml_parser, 'startElement', 'endElement');
  xml_set_character_data_handler($xml_parser, 'characterData');
  if ( !($fp = fopen($_FILES['title']['tmp_name'],'r')) ) die('could not open XML input');
  while ($data = fread($fp,4096))
  {
    if ( !xml_parse($xml_parser, $data, feof($fp)) ) die(sprintf('XML error: %s at line %d', xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
  }
  xml_parser_free($xml_parser);
    
  break;
  
  // ========
  }}
  // ========

  if ( empty($error) )
  {
    unlink($_FILES['title']['tmp_name']);
    $oVIP->EndMessage(NULL,$L['import']['S_import'],'admin',0);
  }

}

// --------
// HTML START
// --------

$bJava=false;

include('qti_adm_p_header.php');
include('qti_adm_p_title.php');

if ( isset($_SESSION['m_import']['format']) )    $strFormat = $_SESSION['m_import']['format'];
if ( isset($_SESSION['m_import']['dest']) )      $intDest   = $_SESSION['m_import']['dest'];
if ( isset($_SESSION['m_import']['status']) )    $strStatus = $_SESSION['m_import']['status'];
if ( isset($_SESSION['m_import']['dropbbc']) )   $bDropbbc  = $_SESSION['m_import']['dropbbc'];
if ( isset($_SESSION['m_import']['dropreply']) ) $bDropreply= $_SESSION['m_import']['dropreply'];
if ( isset($_SESSION['m_import']['droptags']) )  $bDroptags = $_SESSION['m_import']['droptags'];
if ( isset($_SESSION['m_import']['dropdate']) )  $bDropdate = $_SESSION['m_import']['dropdate'];
if ( isset($_SESSION['m_import']['skip']) )      $bSkipfirst= $_SESSION['m_import']['skip'];
if ( isset($_SESSION['m_import']['delimit']) )   $strDelimit= $_SESSION['m_import']['delimit'];
if ( isset($_SESSION['m_import']['enclose']) )   $strEnclose= $_SESSION['m_import']['enclose'];
if ( isset($_SESSION['m_import']['null']) )      $strNull   = $_SESSION['m_import']['null'];

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
function ShowParam(theFormat)
{
  if (theFormat=="XML")
  {
  document.getElementById("tr_delimiter").style.display="none";
  document.getElementById("tr_enclose").style.display="none";
  document.getElementById("tr_null").style.display="none";
  document.getElementById("tr_firstline").style.display="none";
  }
  else
  {
  document.getElementById("tr_delimiter").style.display="table-row";
  document.getElementById("tr_enclose").style.display="table-row";
  document.getElementById("tr_null").style.display="table-row";
  document.getElementById("tr_firstline").style.display="table-row";
  }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" enctype="multipart/form-data" onsubmit="return ValidateForm(this);">
<input type="hidden" name="maxsize" value="5242880"/>
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['File'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="title">',$L['File'],'</label></td>
<td class="td_o"><input type="file" id="title" name="title" size="32"/></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['Adm_settings'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="format">',$L['Format'],'</label></td>
<td class="td_o"><select id="format" name="format" onchange="return ShowParam(this.value);">
<option value="XML"',($strFormat=='SQL' ? QSEL : ''),'>XML</option>
<option value="CSV"',($strFormat=='CSV' ? QSEL : ''),'>CSV</option>
</select></td>
</tr>
';
echo '<tr id="tr_delimiter" class="data_o" ',($strFormat=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first"><label for="delimit">',$L['import']['Delimiter'],'</label></td>
<td class="td_o"><input type="text" id="delimit" name="delimit" size="1" maxlength="5" value="',$strDelimit,'"/></td>
</tr>
';
echo '<tr id="tr_enclose" class="data_o" ',($strFormat=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first"><label for="enclose">',$L['import']['Encloser'],'</label></td>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="5" value="',htmlspecialchars($strEnclose),'"/></td>
</tr>
';
echo '<tr id="tr_null" class="data_o" ',($strFormat=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first"><label for="null">',$L['import']['Null'],'</label></td>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$strNull,'"/> ',$L['import']['H_Null'],'</td>
</tr>
';
echo '<tr id="tr_firstline" class="data_o" ',($strFormat=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first">',$L['import']['First_line'],'</td>
<td class="td_o"><input type="checkbox" id="skip" name="skip"',($bSkipfirst ? QCHE : ''),'/> <label for="skip">',$L['import']['HFirst_line'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['Content'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['import']['Drop_tags'],'</td>
<td class="td_o"><input type="checkbox" id="droptags" name="droptags"',($bDroptags ? QCHE : ''),'/> <label for="droptags">',$L['import']['HDrop_tags'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['import']['Drop_reply'],'</td>
<td class="td_o"><input type="checkbox" id="dropreply" name="dropreply"',($bDropreply ? QCHE : ''),'/> <label for="dropreply">',$L['import']['HDrop_reply'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['import']['Drop_bbc'],'</td>
<td class="td_o"><input type="checkbox" id="dropbbc" name="dropbbc"',($bDropbbc ? QCHE : ''),'/> <label for="dropbbc">',$L['import']['HDrop_bbc'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['import']['Drop_date'],'</td>
<td class="td_o"><input type="checkbox" id="dropdate" name="dropdate"',($bDropdate ? QCHE : ''),'/> <label for="dropdate">',$L['import']['HDrop_date'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2">',$L['Destination'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="section">',$L['import']['Destination'],'</label></td>
<td class="td_o"><select id="section" name="section">',QTasTag(QTarrget(GetSections('A'))),'</select> <a href="qti_adm_sections.php">',$L['Section_add'],'</a></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="status">',$L['Status'],'</label></td>
<td class="td_o"><select id="status" name="status">
';
foreach($oVIP->statuses as $strKey=>$arrValues)
{
echo '<option value="',$strKey,'"',($strStatus==$strKey ? QSEL : ''),'>',$strKey.' '.$arrValues['name'].'</option>',N;
}
echo '</select></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="2" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></td>
</tr>
</table>
</form>
';

// HTML END

include('qti_adm_p_footer.php');

?>